Annotation of openbsd/fw_update/fw_install.sh, Revision 1.86
1.1 afresh1 1: #!/bin/ksh
1.36 afresh1 2: # $OpenBSD$
1.50 afresh1 3: #
1.38 afresh1 4: # Copyright (c) 2021 Andrew Hewus Fresh <afresh1@openbsd.org>
5: #
6: # Permission to use, copy, modify, and distribute this software for any
7: # purpose with or without fee is hereby granted, provided that the above
8: # copyright notice and this permission notice appear in all copies.
9: #
10: # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
11: # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
12: # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
13: # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
14: # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
15: # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
16: # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
17:
1.50 afresh1 18: set -o errexit -o pipefail -o nounset
1.85 afresh1 19: set +o monitor
1.77 afresh1 20: export PATH=/usr/bin:/bin:/usr/sbin:/sbin
1.50 afresh1 21:
22: CFILE=SHA256.sig
23: DESTDIR=${DESTDIR:-}
24: FWPATTERNS="${DESTDIR}/usr/share/misc/firmware_patterns"
25:
26: VNAME=${VNAME:-$(sysctl -n kern.osrelease)}
27: VERSION=${VERSION:-"${VNAME%.*}${VNAME#*.}"}
28:
29: HTTP_FWDIR="$VNAME"
1.52 afresh1 30: VTYPE=$( sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" \
31: /var/run/dmesg.boot | sed '$!d' )
1.50 afresh1 32: [[ $VTYPE == -!(stable) ]] && HTTP_FWDIR=snapshots
1.22 afresh1 33:
1.50 afresh1 34: FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
35: FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
1.8 afresh1 36:
1.69 afresh1 37: LOCALSRC=
38:
1.8 afresh1 39: tmpdir() {
40: local _i=1 _dir
41:
1.50 afresh1 42: # If we're not in the installer,
1.79 afresh1 43: # we have mktemp and a more hostile environment.
1.50 afresh1 44: if [ -x /usr/bin/mktemp ]; then
45: _dir=$( mktemp -d "${1}-XXXXXXXXX" )
1.44 afresh1 46: else
1.50 afresh1 47: until _dir="${1}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do
1.44 afresh1 48: ((++_i < 10000)) || return 1
49: done
50: fi
1.50 afresh1 51:
1.8 afresh1 52: echo "$_dir"
53: }
1.6 afresh1 54:
1.50 afresh1 55: fetch() {
1.85 afresh1 56: local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _pid _exit
1.6 afresh1 57:
1.79 afresh1 58: # If we're not in the installer,
59: # we have su(1) and doas(1) is unlikely to be configured.
1.85 afresh1 60: set -o monitor # make sure ftp gets its own process group
61: (
1.53 afresh1 62: if [ -x /usr/bin/su ]; then
1.85 afresh1 63: exec /usr/bin/su -s /bin/ksh "$_user" -c \
1.69 afresh1 64: "/usr/bin/ftp -D 'Get/Verify' -Vm -o- '$_src'" > "$_dst"
1.42 afresh1 65: else
1.85 afresh1 66: exec /usr/bin/doas -u "$_user" \
1.69 afresh1 67: /usr/bin/ftp -D 'Get/Verify' -Vm -o- "$_src" > "$_dst"
1.42 afresh1 68: fi
1.85 afresh1 69: ) & _pid=$!
70: set +o monitor
71:
72: trap "kill -TERM '-$_pid'; exit 1" EXIT INT QUIT ABRT TERM
73:
74: SECONDS=0
75: _last=0
76: while kill -0 -"$_pid" 2>/dev/null; do
77: if [[ $SECONDS -gt 12 ]]; then
78: set -- $( ls -ln "$_dst" 2>/dev/null )
79: if [[ $_last -ne $5 ]]; then
80: _last=$5
81: SECONDS=0
82: sleep 1
83: else
84: kill -INT -"$_pid"
85: echo "fetch timed out" >&2
86: fi
87: else
88: sleep 1
89: fi
90: done
91:
92: set +o errexit
93: wait "$_pid"
94: _exit=$?
95: set -o errexit
96:
97: trap "" EXIT INT QUIT ABRT TERM
1.6 afresh1 98:
1.50 afresh1 99: if [ "$_exit" -ne 0 ]; then
1.69 afresh1 100: rm -f "$_dst"
101: echo "Cannot fetch $_src" >&2
1.50 afresh1 102: return 1
103: fi
1.6 afresh1 104: }
105:
1.50 afresh1 106: verify() {
107: # On the installer we don't get sha256 -C, so fake it.
1.69 afresh1 108: if ! fgrep -qx "SHA256 (${1##*/}) = $( /bin/sha256 -qb "$1" )" "$CFILE"; then
109: echo "Checksum test for ${1##*/} failed." >&2
1.50 afresh1 110: return 1
111: fi
1.6 afresh1 112: }
113:
1.50 afresh1 114: devices_needing_firmware() {
1.83 afresh1 115: local _d _m _line _dmesgtail _last=''
1.1 afresh1 116:
1.50 afresh1 117: # When we're not in the installer, the dmesg.boot can
118: # contain multiple boots, so only look in the last one
1.84 afresh1 119: sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot |
120: grep -e "^[a-z][a-z]*[0-9]" -e " not configured " | { \
1.83 afresh1 121: _m=0
122: set -A _dmesgtail
123: while read -r _line; do
124: _dmesgtail[$_m]="$_line"
1.86 ! afresh1 125: _m=$(( _m + 1 ))
1.83 afresh1 126: done
1.50 afresh1 127:
1.83 afresh1 128: grep -v '^[[:space:]]*#' "$FWPATTERNS" |
129: while read -r _d _m; do
130: [ "$_d" = "$_last" ] && continue
131: [ "$_m" ] || _m="^${_d}[0-9] at "
1.50 afresh1 132:
1.83 afresh1 133: if [ "$_m" = "${_m#^}" ]; then
134: _m="*$_m"
135: else
136: _m="${_m#^}"
137: fi
138:
139: for _line in "${_dmesgtail[@]}"; do
140: if [[ $_line = ${_m}* ]]; then
141: echo "$_d"
142: _last="$_d"
143: fi
144: done
145: done
146: }
1.50 afresh1 147: }
1.14 afresh1 148:
1.50 afresh1 149: firmware_filename() {
1.56 afresh1 150: local _f
151: _f="$( sed -n "s/.*(\($1-firmware-.*\.tgz\)).*/\1/p" "$CFILE" | sed '$!d' )"
152: ! [ "$_f" ] && echo "Unable to find firmware for $1" >&2 && return 1
153: echo "$_f"
1.50 afresh1 154: }
1.7 afresh1 155:
1.57 afresh1 156: firmware_devicename() {
157: local _d="${1##*/}"
158: _d="${_d%-firmware-*}"
159: echo "$_d"
160: }
161:
1.50 afresh1 162: installed_firmware() {
163: for fw in "${DESTDIR}/var/db/pkg/$1-firmware"*; do
164: [ -e "$fw" ] || continue
165: echo "${fw##*/}"
166: done
167: }
1.1 afresh1 168:
1.50 afresh1 169: add_firmware () {
1.74 afresh1 170: local _f="${1##*/}"
171: local _pkgdir="${DESTDIR}/var/db/pkg/${_f%.tgz}"
1.50 afresh1 172: ftp -D "Install" -Vmo- "file:${1}" |
1.73 afresh1 173: tar -s ",^\+,${_pkgdir}/+," \
1.69 afresh1 174: -s ",^firmware,${DESTDIR}/etc/firmware," \
175: -C / -zxphf - "+*" "firmware/*"
1.1 afresh1 176:
1.50 afresh1 177: # TODO: Should we mark these so real fw_update can -Drepair?
1.73 afresh1 178: ed -s "${_pkgdir}/+CONTENTS" <<EOL
1.50 afresh1 179: /^@comment pkgpath/ -1a
180: @option manual-installation
181: @option firmware
182: @comment install-script
183: .
184: w
185: EOL
186: }
1.22 afresh1 187:
1.50 afresh1 188: delete_firmware() {
1.51 afresh1 189: local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"
1.22 afresh1 190:
1.50 afresh1 191: # TODO: Check hash for files before deleting
192: echo "Uninstalling $_pkg"
1.51 afresh1 193: _cwd="${_pkgdir}/$_pkg"
1.50 afresh1 194:
1.51 afresh1 195: set -A _remove -- "${_cwd}/+CONTENTS" "${_cwd}"
1.50 afresh1 196:
197: while read -r c g; do
198: case $c in
1.51 afresh1 199: @cwd) _cwd="${DESTDIR}$g"
1.50 afresh1 200: ;;
201: @*) continue
202: ;;
1.52 afresh1 203: *) set -A _remove -- "$_cwd/$c" "${_remove[@]}"
1.50 afresh1 204: ;;
205: esac
206: done < "${_pkgdir}/${_pkg}/+CONTENTS"
207:
208: # We specifically rm -f here because not removing files/dirs
209: # is probably not worth failing over.
210: for _r in "${_remove[@]}" ; do
211: if [ -d "$_r" ]; then
212: # Try hard not to actually remove recursively
213: # without rmdir on the install media.
214: [ "$_r/*" = "$( echo "$_r"/* )" ] && rm -rf "$_r"
215: else
216: rm -f "$_r"
1.22 afresh1 217: fi
218: done
1.50 afresh1 219: }
1.1 afresh1 220:
1.59 afresh1 221: usage() {
1.81 afresh1 222: echo "usage: fw_install [-DL] [driver | file [...]]"
1.59 afresh1 223: exit 2
224: }
225:
1.68 afresh1 226: INSTALL=true
227: DOWNLOAD=true
228:
1.82 afresh1 229: while getopts DL name
1.59 afresh1 230: do
231: case "$name" in
1.68 afresh1 232: # "download only" means local dir and don't install
1.81 afresh1 233: D) LOCALSRC=. INSTALL=false ;;
1.69 afresh1 234: L) LOCALSRC=. ;;
1.59 afresh1 235: ?) usage 2 ;;
236: esac
237: done
238: shift $((OPTIND - 1))
239:
1.68 afresh1 240: # If we're installing from a local dir
241: # we don't want to download anything
1.69 afresh1 242: [ "$LOCALSRC" ] && "$INSTALL" && DOWNLOAD=false
243: [ "$LOCALSRC" ] || LOCALSRC="$( tmpdir "${DESTDIR}/tmp/fw_install" )"
1.64 afresh1 244:
1.78 afresh1 245: CFILE="$LOCALSRC/$CFILE"
246:
1.58 afresh1 247: set -A devices -- "$@"
248:
249: [ "${devices[*]:-}" ] ||
250: set -A devices -- $( devices_needing_firmware )
1.1 afresh1 251:
1.65 afresh1 252: if [ ! "${devices[*]:-}" ]; then
1.50 afresh1 253: echo "No devices found which need firmware files to be downloaded."
254: exit
255: fi
256:
1.71 afresh1 257: if "$DOWNLOAD"; then
1.64 afresh1 258: fetch "$CFILE"
259: ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
260: echo "Signature check of SHA256.sig failed" >&2 && exit 1
261: fi
1.50 afresh1 262:
1.70 afresh1 263: for f in "${devices[@]}"; do
264: d="$( firmware_devicename "$f" )"
265:
1.58 afresh1 266: if [ "$f" = "$d" ]; then
267: f=$( firmware_filename "$d" || true )
268: [ "$f" ] || continue
1.69 afresh1 269: f="$LOCALSRC/$f"
1.76 afresh1 270: elif ! "$INSTALL" && ! grep -Fq "($f)" "$CFILE" ; then
1.70 afresh1 271: echo "Cannot download local file $f" >&2
272: exit 2
1.58 afresh1 273: fi
274:
1.50 afresh1 275: set -A installed -- $( installed_firmware "$d" )
276:
1.68 afresh1 277: if "$INSTALL" && [ "${installed[*]:-}" ]; then
1.65 afresh1 278: for i in "${installed[@]}"; do
1.58 afresh1 279: if [ "${f##*/}" = "$i.tgz" ]; then
1.50 afresh1 280: echo "$i already installed"
1.11 afresh1 281: continue 2
1.1 afresh1 282: fi
283: done
1.50 afresh1 284: fi
1.1 afresh1 285:
1.72 afresh1 286: if [ -e "$f" ]; then
287: if "$DOWNLOAD"; then
288: echo "Verify existing ${f##*/}"
289: verify "$f" || continue
290: # else assume it was verified when downloaded
291: fi
1.75 afresh1 292: elif "$DOWNLOAD"; then
293: fetch "$f" || continue
294: verify "$f" || continue
295: elif "$INSTALL"; then
1.72 afresh1 296: echo "Cannot install ${f##*/}, not found" >&2
297: continue
1.58 afresh1 298: fi
1.60 afresh1 299:
1.68 afresh1 300: "$INSTALL" || continue
1.11 afresh1 301:
1.65 afresh1 302: if [ "${installed[*]:-}" ]; then
1.50 afresh1 303: for i in "${installed[@]}"; do
304: delete_firmware "$i"
305: done
306: fi
1.11 afresh1 307:
1.50 afresh1 308: add_firmware "$f"
309: done
1.1 afresh1 310:
FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>